import numpy as np
import emcee
from numpy.random import randn, rand
import scipy
from scipy.stats import norm

import pickle
#from schwimmbad import MPIPool
import time

import sys

import matlab.engine

from helpers import *

eng = matlab.engine.start_matlab()
eng.addpath('../src', nargout=0)


eng.connect_comsol(nargout=0)
model = eng.oneSided_Ge_coarse()


#freqs, SEsub, SEcoat, SEbulk = eng.run_experiment(x, params, model, nargout=4)

#parameters = ['R', 'h_s', 'Y_s', 'nu_s', 'rho_s', 't', 'Y_c', 'nu_c', 'rho_c']

# model parameters to be inferred, and nominal (prior) values
params0 = {
    'thickness': 100, # substrate thickness in um
    'coating': 500, # coating thickness in nm
    'lphi_coat': -4.1, # log10 of loss angle for coating
    'lphi_sub': -8.1, # log10 of loss angle for substrate
    'lphi_clamp': -1.1 # log10 of loss angle for clamp
}

# hyperparameters
hp = {
    'run_name': 'inference1', # prepended to filenames
    'sig_geom': 0.05, # fractional uncertainty on nominal geometric parameters
    'sig_loss': 1, # absolute uncertainty on nominal log loss parameters
    'sig_f': 0.1, # absolute uncertainty on frequency measurements, in Hz
    'sig_Q': 0.01, # fractional uncertainty on log10(Q) measurements
    'p_geom': ['thickness', 'coating'], # which parameters are geometric
    'p_loss': ['lphi_coat', 'lphi_sub', 'lphi_clamp'], # which parameters are losses
    'nwalkers': 25, # number of emcee walkers
    'ndim': len(params0),
    'params0': params0,
    'model': model,
    'eng': eng,
    'nsteps': 10000 # max number of MCMC steps
}


x0, p0, y0, data, theta0 = generateData(hp)
# x0 is the vector of true values of parameters p0
# y0 are the experimental outcomes predicted by model for x0
# data are "experimental data" generated by adding Gaussian noise to y0
# theta0 are starting points for mcmc walkers in a 1% ball around params0

print('x0, p0, y0:')
print(x0)
print(p0)
print(y0)

with open(hp['run_name'] + '_setup.pkl', 'wb') as f:
    pickle.dump({'x0':x0, 'p0':p0, 'y0':y0, 'data':data, 'theta0':theta0}, f)

#import os
#os.environ["OMP_NUM_THREADS"] = "1"

# Set up the backend
# Don't forget to clear it in case the file already exists
filename = hp['run_name'] + "_progress" +  ".h5"
backend = emcee.backends.HDFBackend(filename)
backend.reset(hp['nwalkers'], hp['ndim'])

sampler = emcee.EnsembleSampler(hp['nwalkers'], hp['ndim'], lnpost,
                                kwargs={'params':p0, 'hp':hp, 'data':data},
                                backend=backend
)

start = time.time()

# We'll track how the average autocorrelation time estimate changes
index = 0
autocorr = np.empty(hp['nsteps'])

# This will be useful to testing convergence
old_tau = np.inf

# Now we'll sample for up to max_n steps
for sample in sampler.sample(theta0, iterations=hp['nsteps'], progress=True):
    # Only check convergence every 25 steps
    if sampler.iteration % 25:
        continue

    tau = sampler.get_autocorr_time(tol=0)
    autocorr[index] = np.mean(tau)
    index += 1

    # Check convergence
    converged = np.all(tau * 100 < sampler.iteration)
    converged &= np.all(np.abs(old_tau - tau) / tau < 0.01)
    if converged:
        break
    old_tau = tau

#sampler.run_mcmc(theta0, hp['nsteps'], progress=True)
end = time.time()
print(end - start)

#with open(hp['run_name'] + '_sampler.pkl', 'wb') as f:
#    pickle.dump(, f)

eng.ModelUtil.disconnect(nargout=0)
